# BEGIN COPYRIGHT

# *************************************************************************

# Licensed Materials - Property of IBM 

# 5724-L01, 5655-N53, 5724-I82, 5655-R15

# (C) Copyright IBM Corporation 2009. All rights reserved. 

# US Government Users Restricted Rights - Use, duplication, or disclosure

# restricted by GSA ADP Schedule Contract with IBM Corp.

# *************************************************************************

# END COPYRIGHT



import java



####################################################

##

## Check if the appName exists.

##

####################################################



def isAppExist(appName):

	try :

		AdminApp.listModules(appName)

	except :

		print "*** ",appName,"is not installed."

		return 0

	print  "*** ",appName,"is installed."

	return 1





####################################################

##

## Check if the $adminModule exists in the $appName module.

##

####################################################



def isAdminModuleExist (appName ,appModule) :

	try :

		apps = AdminApp.listModules(appName)

	except : 

		print "Application ",appName," does not exists."

		raise	

	

	if(apps.find(appModule)>0) :

		print "module",appModule," exists in the application ", appName

		return 1

	

	print "module",appModule," does not exists in the application ", appName	

	return 0





################################

##

## Delete the admin module war file

##

################################

def deleteAdminModule(appName,adminModule) :

	try :

		# delete the module inside the application

		AdminApp.update(appName, 'modulefile', '[-operation delete -contenturi '+adminModule+']')

	except :

		print "Error while deleting the existing "+adminModule+" module"

		raise

			

		

			

################################

##

## Deploy the admin module war file

##

################################

def deployAdminModule (appName, adminModule, WASInstallRoot, inNodeName, contextRoot) :

	

	appExist =  isAppExist(appName)

	

	# if application does not exist, return without deploy.

	if (appExist == 0) :

		print "The application"+ appName+" is not installed."

		return

	

	

	adminModuleExist = isAdminModuleExist(appName,adminModule)

	if (adminModuleExist == 1) :

	         deleteAdminModule(appName,adminModule)

	         

	

	warfile = WASInstallRoot+"/systemApps/"+appName+".ear/"+adminModule

	

	

	nodesList = AdminConfig.list("Node").split(java.lang.System.getProperty("line.separator"))

	print nodesList

	for node in  nodesList :

		nodeName = AdminConfig.showAttribute(node,"name")

		if (nodeName == inNodeName) :

			serversList = AdminConfig.list("Server",node).split(java.lang.System.getProperty("line.separator"))

			

			for server in serversList :

				serverName = AdminConfig.showAttribute(server ,"name")

				try :

					AdminApp.update(appName, 'modulefile', '[-operation add -contents ' + '"' + warfile + '"' + ' -node '+nodeName+ ' -server '+serverName+' -contenturi '+adminModule+' -custom paavalidation=true -usedefaultbindings -contextroot '+contextRoot+' -usedefaultbindings -MapWebModToVH [[.* .* admin_host]]]')

					AdminConfig.save()                   			

				except :

					print "Could not deploy "+adminModule+" in "+appName+" due to error"

					raise

                        

                        print "Completed deployment of ",adminModule," in "+appName+" module."

                        	



#------------------------------------------------------------------------

# MAIN

#

# Deploy the adminModule

# 

# Usage:installSystemModules.py <appName>  <adminModule> <nodeName> <contextRoot>

#		

#		appName : Name of the system application

#		adminModulle : Name of the admin module

#              nodeName : Name of the node 

#		contextRoot: context root name

#--------------------------------------------------------------------------



if ( len(sys.argv) != 4) :

	print "Error: Invalid arguments!"

	print "Usage:installSystemModules.py <appName>  <adminModule> <nodeName> <contextRoot>"

else :

	

	 appName  = sys.argv[0]

	 adminModule = sys.argv[1]

	 nodeName = sys.argv[2]

	 contextRoot = sys.argv[3]

	 deployAdminModule(appName,adminModule,java.lang.System.getProperty('was.install.root'),nodeName,contextRoot)

