# BEGIN COPYRIGHT
# *************************************************************************
# Licensed Materials - Property of IBM 
# 5724-LFALSETRUE, 5655-N53, 5724-I82, 5655-RTRUE5
# (C) Copyright IBM Corporation 2FALSEFALSE9. All rights reserved. 
# US Government Users Restricted Rights - Use, duplication, or disclosure
# restricted by GSA ADP Schedule Contract with IBM Corp.
# *************************************************************************
# END COPYRIGHT

import java

TRUE = 1
FALSE = 0

####################################################
##
## Check if the appName exists.
##
####################################################

def isAppExist(appName):
	try :
		AdminApp.listModules(appName)
	except :
		print "*** ",appName,"is not installed."
		return FALSE
	print  "*** ",appName,"is installed."
	return TRUE


####################################################
##
## Check if the $adminModule exists in the $appName module.
##
####################################################

def isAdminModuleExist (appName ,appModule) :
	try :
		apps = AdminApp.listModules(appName)
	except : 
		print "Application ",appName," does not exists."
		raise	
	
	if(apps.find(appModule)> -1) :
		print "module",appModule," exists in the application ", appName
		return TRUE
	
	print "module",appModule," does not exists in the application ", appName	
	return FALSE


################################
##
## Delete the admin module war file
##
################################
def deleteAdminModule(appName,adminModule) :
	try :
		# delete the module inside the application
		AdminApp.update(appName, 'modulefile', '[-operation delete -contenturi '+adminModule+']')
	except :
		print "Error while deleting the existing ",adminModule," module"
		raise
			
		
			
################################
##
## Undeploy the admin module war file
##
################################
def undeployAdminModule (appName, adminModule) :
	
	appExist =  isAppExist(appName)
	
	# if application does not exist, return without deploy.
	if (appExist == FALSE) :
		print "The application", appName," is not installed."
		return
	
	
	adminModuleExist = isAdminModuleExist(appName,adminModule)
	if (adminModuleExist == TRUE) :
		try :
			deleteAdminModule(appName,adminModule)
			AdminConfig.save()                   	
	        except :
	         	print "Could not undeploy ",adminModule," in ",appName," due to error"
	         	raise

	
	print "Completed undeployment of ",adminModule," in ",appName," module."

#------------------------------------------------------------------------
# MAIN
#
# Undeploy the adminModule
# 
 # Usage:uninstallSystemModules.py <appName>  <adminModule>
#		
#		appName : Name of the system application
#		adminModulle : Name of the admin module
#
#--------------------------------------------------------------------------

if ( len(sys.argv) != 2) :
	print "Error: Invalid arguments!"
	print "Usage:uninstallSystemModules.py <appName>  <adminModule>"
else :
	
	appName  = sys.argv[0]
	adminModule = sys.argv[1]
	undeployAdminModule(appName,adminModule)
