#***********************************************************************
# Licensed Material - Property of IBM
#
# 5724-M24
#
# (c) Copyright IBM Corp. 2008.  All rights reserved.
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#************************************************************************

#Sample command.
#wsadmin.bat -user naveen -password naveen -f useVMM.py


####################################################################
# This script sets the useVMM flag to true if VMM is configured
#    
####################################################################

#Conditional variables
True = 1==1
False = 1==0
isVMMConfigured = True

celllist = AdminConfig.list("Cell").splitlines()
cellid = celllist[0]
i= cellid.find('(')
cellName=cellid[0:i]

security = AdminConfig.getid('/Cell:'+ cellName +'/Security:/')
activeRegistry = AdminConfig.showAttribute(security,"activeUserRegistry")


#You will not have the property registryClassName for other repository providers.
try :
    AdminConfig.showAttribute(activeRegistry,"registryClassName")
except:
    isVMMConfigured = False
    print "INFO - The profile doesn't uses VMM,hence not setting variable useVMMForUsers"

if(isVMMConfigured):
    #Set the DA Event Tracer. Todo check for already existing
    attr1 = ["name","useVMMForUsers"]
    attr2 = ["nameInNameSpace","useVMMForUsers"]
    attr3 = ["stringToBind","true"]
    options = []
    options.append(attr1)
    options.append(attr2)
    options.append(attr3)
    AdminConfig.create("StringNameSpaceBinding",cellid,options)
    AdminConfig.save()
    print "INFO - Set the useVMMForUsers=true"